Inconsistent behavior of 10/StringlO's each methods when called with nil as a separator, limit and
chomp: true
Description
IO's and StringlO's #each method (and similar ones - #gets, #readline etc) behave in a different way in the following case:

e separator is nil
e |limit is passed
e chomp: true passed

In this case StringlO#each removes trailing \n but I0#each does not:

StringIO.new ("abc\n\ndef\n") .each(nil, 2, chomp: true).to_a
#=> [Ilabll’ Ilc", ll\ndll’ Ilefll’ IlllJ

File.open('chomp.txt') .each(nil, 2, chomp: true).to_a
#:> ["ab", "c\n", "\nd", "ef", "\n"J

The file has the same content:

File.read('chomp.txt"');
#=> "abc\n\ndef\n"

Expected behavior - both methods return the same result.

Related issues:
Related to Ruby - Bug #18768: Inconsistent behavior of 10, StringlO and Strin... Closed

Associated revisions

Revision adaaf12857ce41d35b282e3fb5aa330934ce45c6 - 05/30/2022 04:01 AM - jeremyevans (Jeremy Evans)

[ruby/stringio] Ignore chomp keyword for nil separator

nil separator means no separator at all, so nothing should be
chomped.

Partial fix for Ruby [Bug #18770]

https://github.com/ruby/stringio/commit/feaa2ec631

Revision adaaf12857ce41d35b282e3fb5aa330934ce45¢c6 - 05/30/2022 04:01 AM - jeremyevans (Jeremy Evans)

[ruby/stringio] Ignore chomp keyword for nil separator

nil separator means no separator at all, so nothing should be
chomped.

Partial fix for Ruby [Bug #18770]

https://github.com/ruby/stringio/commit/feaa2ec631

Revision adaaf128 - 05/30/2022 04:01 AM - jeremyevans (Jeremy Evans)

[ruby/stringio] Ignore chomp keyword for nil separator

nil separator means no separator at all, so nothing should be
chomped.
https://github.com/ruby/stringio/commit/feaa2ec631
https://github.com/ruby/stringio/commit/feaa2ec631

Partial fix for Ruby [Bug #18770]

https://github.com/ruby/stringio/commit/feaa2ec631

Revision 04f86ad0b5d2fe4711ff300d855228a6aed55f33 - 07/21/2022 03:13 PM - jeremyevans (Jeremy Evans)

Do not chomp trailing line separator IO#each with nil separator and chomp

nil separator means no sepator, so chomp should not remove a line
separator.

Partially Fixes [Bug #18770]
Revision 04f86ad0b5d2fe4711ff300d855228a6aed55f33 - 07/21/2022 03:13 PM - jeremyevans (Jeremy Evans)
Do not chomp trailing line separator IO#each with nil separator and chomp

nil separator means no sepator, so chomp should not remove a line
separator.

Partially Fixes [Bug #18770]
Revision 04f86ad0 - 07/21/2022 03:13 PM - jeremyevans (Jeremy Evans)
Do not chomp trailing line separator I0#each with nil separator and chomp

nil separator means no sepator, so chomp should not remove a line
separator.

Partially Fixes [Bug #18770]
Revision 7223c0da152114c84e1c4261a282faaea21646fb - 07/21/2022 07:55 PM - jeremyevans (Jeremy Evans)
Do not chomp trailing line separator IO#each with nil separator and chomp

nil separator means no sepator, so chomp should not remove a line
separator.

Partially Fixes [Bug #18770]
Revision 7223c0da152114c84e1c4261a282faaea21646fb - 07/21/2022 07:55 PM - jeremyevans (Jeremy Evans)
Do not chomp trailing line separator I0O#each with nil separator and chomp

nil separator means no sepator, so chomp should not remove a line
separator.

Partially Fixes [Bug #18770]
Revision 7223c0da - 07/21/2022 07:55 PM - jeremyevans (Jeremy Evans)
Do not chomp trailing line separator I0#each with nil separator and chomp

nil separator means no sepator, so chomp should not remove a line
separator.

Partially Fixes [Bug #18770]

History

#1 - 05/26/2022 06:42 PM - jeremyevansO0 (Jeremy Evans)
- Related to Bug #18768: Inconsistent behavior of 10, StringlO and String each_line methods when return paragraph and chomp: true passed added

#2 - 05/26/2022 09:28 PM - jeremyevans0 (Jeremy Evans)

| think both IO#each and StringlO#each behavior is wrong when combining nil with chomp. My opinion is that a nil separator means there is no
separator at all, and therefore chomp should either raise an error or be ignored if nil is the separator. Assuming that ignoring chomp is desired
behavior for nil separator, it follows:

e |O#teach behavior for nil and chomp with a limit is correct. However, I0#each for nil and chomp without a limit is not, since it removes a final line
separator.

¢ StringlO#each behavior for nil and chomp is wrong, regardless of whether a limit is used.
https://github.com/ruby/stringio/commit/feaa2ec631

This issue is related to String#each_line, but the nil and chomp combination there is handled correctly, not removing any characters (it doesn't
support limit).

Note that Ruby has current tests for the |O#each behavior for nil and chomp without limit removing the trailing line separator. So the current behavior
for that is definitely expected, though | consider it undesirable.

I've added PRs for Ruby (hitps://github.com/ruby/ruby/pull/5959) and StringlO (https:/github.com/ruby/stringio/pull/28) for this.

#3 - 05/30/2022 04:00 PM - jeremyevans (Jeremy Evans)
- Status changed from Open to Closed

Applied in changeset git|adaaf12857ce41d35b282e3fb5aa330934ce45c6.

[ruby/stringio] Ignore chomp keyword for nil separator

nil separator means no separator at all, so nothing should be
chomped.

Partial fix for Ruby [Bug #18770]

https://github.com/ruby/stringio/commit/feaa2ec631

#4 - 06/06/2022 05:38 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Closed to Open

#5 - 07/21/2022 12:26 PM - mame (Yusuke Endoh)

We discussed this at the dev meeting, and @matz (Yukihiro Matsumoto) agreed with @jeremyevans0 (Jeremy Evans).

#6 - 07/21/2022 03:13 PM - jeremyevans (Jeremy Evans)
- Status changed from Open to Closed

Applied in changeset git|04{86ad0b5d2fe4711ff300d855228a6aed55f33.

Do not chomp trailing line separator I0#each with nil separator and chomp

nil separator means no sepator, so chomp should not remove a line
separator.

Partially Fixes [Bug #18770]

#7 - 07/21/2022 03:34 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Closed to Open

#8 - 07/21/2022 07:55 PM - jeremyevans (Jeremy Evans)
- Status changed from Open to Closed

Applied in changeset git|7223c0da152114c84e1c4261a282faaea21646fb.

Do not chomp trailing line separator IO#each with nil separator and chomp

nil separator means no sepator, so chomp should not remove a line
separator.

Partially Fixes [Bug #18770]
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/adaaf12857ce41d35b282e3fb5aa330934ce45c6
